#include "defs.h"

const unsigned int HEAP_SIZE = 80;

void main() {
Sensor *sensor1;
Eeprom *eeprom1;
int i;
char address[7];

     MM_Init();

     sensor1 = (Sensor*)Malloc(1 * sizeof(Sensor));
     (*sensor1).name = "ADS1015";
     (*sensor1).super.read = &sensorRead;
     (*sensor1).super.write = &sensorWrite;

     eeprom1 = (EEPROM*)Malloc(1 * sizeof(EEPROM));
     (*eeprom1).name = "24C256";
     (*eeprom1).super.read = &eepromRead;
     (*eeprom1).super.write = &eepromWrite; // & is optional

     UART1_Init(9600);
     TWI_Init(100000);

#define send(s) s->super.write(&s->super);
#define receive(s) s->super.read(&s->super);

     UART1_Write_Text((*sensor1).name); nl();

     for (i = 0; i < 2; i++) {
          receive(sensor1);
          UART1_Write_Text((*sensor1).value); nl();
          Delay_ms(250);
     }//for_i

     nl(); UART1_Write_Text((*eeprom1).name); nl();
     IntToHex(eeprom1, address);
     UART1_Write_Text("E2prom address "); UART1_Write_Text(address); nl();

     send(eeprom1);
//     UART1_Write('K'); nl();

     Delay_ms(10);

//     UART1_Write_Text((*eeprom1).name); nl();
     receive(eeprom1);
     UART1_Write_Text((*eeprom1).value); nl();

     TWI_Close();

     Free((char*)sensor1, sizeof(sensor1));
     Free((char*)eeprom1, sizeof(eeprom1));

     while(1); // eternity

} // main