
_sensorRead:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 4
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;defs.c,3 :: 		char *sensorRead(TWI *me) {
;defs.c,4 :: 		Sensor *me_ = (Sensor*)me; // explicit downcast
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	STD        Y+0, R2
	STD        Y+1, R3
;defs.c,15 :: 		ADS1015_REG_CONFIG_OS_SINGLE;     // start single conversion bit
	LDI        R27, 131
	STD        Y+2, R27
	LDI        R27, 195
	STD        Y+3, R27
;defs.c,17 :: 		TWI_Start();              // Issue start signal
	CALL       _TWI_Start+0
;defs.c,18 :: 		TWI_Write(ADS1015);       // Address + Write bit
	LDI        R27, 144
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,19 :: 		TWI_Write(0x01);          // Points to config register
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,20 :: 		TWI_Write(config >> 8);   // MSB of the Config register
	LDD        R16, Y+2
	LDD        R17, Y+3
	MOV        R16, R17
	LDI        R17, 0
	MOV        R2, R16
	CALL       _TWI_Write+0
;defs.c,21 :: 		TWI_Write(config & 0xFF); // LSB of the Config register
	LDD        R16, Y+2
	ANDI       R16, 255
	MOV        R2, R16
	CALL       _TWI_Write+0
;defs.c,22 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;defs.c,26 :: 		TWI_Start();
	CALL       _TWI_Start+0
;defs.c,27 :: 		TWI_Write(ADS1015);        // Address + Write bit
	LDI        R27, 144
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,28 :: 		TWI_Write(0x00);           // Points to conversion register
	CLR        R2
	CALL       _TWI_Write+0
;defs.c,29 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;defs.c,30 :: 		TWI_Start();
	CALL       _TWI_Start+0
;defs.c,31 :: 		TWI_Write(ADS1015 | 0x01); // Address + Read bit
	LDI        R27, 145
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,32 :: 		res = TWI_Read(1) << 8;    // MSB of the Conversion register
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Read+0
	MOV        R17, R16
	CLR        R16
; res start address is: 18 (R18)
	MOVW       R18, R16
;defs.c,33 :: 		res |= TWI_Read(0);        // LSB of the Conversion register
	PUSH       R19
	PUSH       R18
	CLR        R2
	CALL       _TWI_Read+0
	POP        R18
	POP        R19
	LDI        R17, 0
	OR         R16, R18
	OR         R17, R19
	MOVW       R18, R16
;defs.c,34 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;defs.c,36 :: 		res >>= 4;
	LDI        R27, 4
	MOVW       R16, R18
L__sensorRead1:
	ASR        R17
	ROR        R16
	DEC        R27
	BRNE       L__sensorRead1
L__sensorRead2:
; res end address is: 18 (R18)
;defs.c,37 :: 		IntToStr(res, datumS);
	LDI        R27, #lo_addr(sensorRead_datumS_L0+0)
	MOV        R4, R27
	LDI        R27, hi_addr(sensorRead_datumS_L0+0)
	MOV        R5, R27
	MOVW       R2, R16
	CALL       _IntToStr+0
;defs.c,38 :: 		(*me_).value = datumS;
	LDD        R16, Y+0
	LDD        R17, Y+1
	MOVW       R30, R16
	ADIW       R30, 6
	LDI        R27, #lo_addr(sensorRead_datumS_L0+0)
	ST         Z+, R27
	LDI        R27, hi_addr(sensorRead_datumS_L0+0)
	ST         Z+, R27
;defs.c,40 :: 		return '0';
	LDI        R16, 48
	LDI        R17, 0
;defs.c,41 :: 		} // sensorRead
;defs.c,40 :: 		return '0';
;defs.c,41 :: 		} // sensorRead
L_end_sensorRead:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _sensorRead

_sensorWrite:

;defs.c,43 :: 		void sensorWrite(TWI *me) { return; } // not applicable
L_end_sensorWrite:
	RET
; end of _sensorWrite

_eepromRead:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;defs.c,45 :: 		char *eepromRead(TWI *me) {
;defs.c,46 :: 		Eeprom *me_ = (Eeprom*)me; // explicit downcast
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	STD        Y+0, R2
	STD        Y+1, R3
;defs.c,50 :: 		TWI_Start();
	CALL       _TWI_Start+0
;defs.c,51 :: 		TWI_Write(_24C256);        // control byte
	LDI        R27, 160
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,52 :: 		TWI_Write(0x23);           // first word address
	LDI        R27, 35
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,53 :: 		TWI_Write(0x23);           // second word address
	LDI        R27, 35
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,54 :: 		TWI_Start();
	CALL       _TWI_Start+0
;defs.c,55 :: 		TWI_Write(_24C256 | 0x01); // control byte
	LDI        R27, 161
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,56 :: 		res = TWI_Read(0);
	CLR        R2
	CALL       _TWI_Read+0
; res start address is: 16 (R16)
	LDI        R17, 0
;defs.c,57 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;defs.c,59 :: 		IntToStr(res, datumE);
	LDI        R27, #lo_addr(eepromRead_datumE_L0+0)
	MOV        R4, R27
	LDI        R27, hi_addr(eepromRead_datumE_L0+0)
	MOV        R5, R27
	MOVW       R2, R16
; res end address is: 16 (R16)
	CALL       _IntToStr+0
;defs.c,60 :: 		(*me_).value = datumE;
	LDD        R16, Y+0
	LDD        R17, Y+1
	MOVW       R30, R16
	ADIW       R30, 6
	LDI        R27, #lo_addr(eepromRead_datumE_L0+0)
	ST         Z+, R27
	LDI        R27, hi_addr(eepromRead_datumE_L0+0)
	ST         Z+, R27
;defs.c,62 :: 		return '0';
	LDI        R16, 48
	LDI        R17, 0
;defs.c,63 :: 		} // eepromRead
;defs.c,62 :: 		return '0';
;defs.c,63 :: 		} // eepromRead
L_end_eepromRead:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _eepromRead

_eepromWrite:

;defs.c,65 :: 		void eepromWrite(TWI *me) {
;defs.c,68 :: 		TWI_Start();
	PUSH       R2
	PUSH       R3
	CALL       _TWI_Start+0
;defs.c,69 :: 		TWI_Write(_24C256); // control byte
	LDI        R27, 160
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,70 :: 		TWI_Write(0x23);    // first word address
	LDI        R27, 35
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,71 :: 		TWI_Write(0x23);    // second word address
	LDI        R27, 35
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,72 :: 		TWI_Write(0x4B);    // data, letter K
	LDI        R27, 75
	MOV        R2, R27
	CALL       _TWI_Write+0
;defs.c,73 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;defs.c,76 :: 		} // eepromWrite
;defs.c,75 :: 		return;
;defs.c,76 :: 		} // eepromWrite
L_end_eepromWrite:
	POP        R3
	POP        R2
	RET
; end of _eepromWrite

defs____?ag:

L_end_defs___?ag:
	RET
; end of defs____?ag
