#include "defs.h"

char *sensorRead(TWI *me) {
Sensor *me_ = (Sensor*)me; // explicit downcast
static char datumS[16];
int res;
unsigned int config = ADS1015_REG_CONFIG_CQUE_NONE    | // Disable the comparator (default val)
                      ADS1015_REG_CONFIG_CLAT_NONLAT  | // Non-latching (default val)
                      ADS1015_REG_CONFIG_CPOL_ACTVLOW | // Alert/Rdy active low   (default val)
                      ADS1015_REG_CONFIG_CMODE_TRAD   | // Traditional comparator (default val)
                      ADS1015_REG_CONFIG_DR_1600SPS   | // 1600 samples per second (default)
                      ADS1015_REG_CONFIG_MODE_SINGLE  | // Single-shot mode (default)
                      ADS1015_REG_CONFIG_PGA_4_096V   | // FSR = 4.096 V
                      ADS1015_REG_CONFIG_MUX_SINGLE_0 | // read AN0
                      ADS1015_REG_CONFIG_OS_SINGLE;     // start single conversion bit

     TWI_Start();              // Issue start signal
     TWI_Write(ADS1015);       // Address + Write bit
     TWI_Write(0x01);          // Points to config register
     TWI_Write(config >> 8);   // MSB of the Config register
     TWI_Write(config & 0xFF); // LSB of the Config register
     TWI_Stop();

//     Delay_ms(5); // not obligatory

     TWI_Start();
     TWI_Write(ADS1015);        // Address + Write bit
     TWI_Write(0x00);           // Points to conversion register
     TWI_Stop();
     TWI_Start();
     TWI_Write(ADS1015 | 0x01); // Address + Read bit
     res = TWI_Read(1) << 8;    // MSB of the Conversion register
     res |= TWI_Read(0);        // LSB of the Conversion register
     TWI_Stop();

     res >>= 4;
     IntToStr(res, datumS);
     (*me_).value = datumS;

     return '0';
} // sensorRead

void sensorWrite(TWI *me) { return; } // not applicable

char *eepromRead(TWI *me) {
Eeprom *me_ = (Eeprom*)me; // explicit downcast
static char datumE[16];
int res;

     TWI_Start();
     TWI_Write(_24C256);        // control byte
     TWI_Write(0x23);           // first word address
     TWI_Write(0x23);           // second word address
     TWI_Start();
     TWI_Write(_24C256 | 0x01); // control byte
     res = TWI_Read(0);
     TWI_Stop();

     IntToStr(res, datumE);
     (*me_).value = datumE;

     return '0';
} // eepromRead

void eepromWrite(TWI *me) {
Eeprom *me_ = (Eeprom*)me; // explicit downcast

     TWI_Start();
     TWI_Write(_24C256); // control byte
     TWI_Write(0x23);    // first word address
     TWI_Write(0x23);    // second word address
     TWI_Write(0x4B);    // data, letter K
     TWI_Stop();

     return;
} // eepromWrite