#ifndef DEFS_H
#define DEFS_H

typedef struct superior {
        char *(*read)(struct superior*);
        void (*write)(struct superior*);
} TWI;

typedef struct inferior1 {
        TWI super; // must be first
        char *name, *value;
} Sensor;

typedef struct inferior2 {
        TWI super; // must be first
        char *name, *value;
} Eeprom;

char *sensorRead(TWI *me);
void sensorWrite(TWI *me);
char *eepromRead(TWI *me);
void eepromWrite(TWI *me);

// https://github.com/adafruit/Adafruit_ADS1X15/blob/master/Adafruit_ADS1015.h
// https://github.com/adafruit/Adafruit_ADS1X15/blob/master/Adafruit_ADS1015.cpp

#define ADS1015_REG_CONFIG_CQUE_NONE    (0x0003)  // Disable the comparator and put ALERT/RDY in high state (default)
#define ADS1015_REG_CONFIG_CLAT_NONLAT  (0x0000)  // Non-latching comparator (default)
#define ADS1015_REG_CONFIG_CPOL_ACTVLOW (0x0000)  // ALERT/RDY pin is low when active (default)
#define ADS1015_REG_CONFIG_CMODE_TRAD   (0x0000)  // Traditional comparator with hysteresis (default)
#define ADS1015_REG_CONFIG_DR_1600SPS   (0x0080)  // 1600 samples per second (default)
#define ADS1015_REG_CONFIG_MODE_SINGLE  (0x0100)  // Power-down single-shot mode (default)
#define ADS1015_REG_CONFIG_MUX_SINGLE_0 (0x4000)  // Single-ended AIN0
#define ADS1015_REG_CONFIG_OS_SINGLE    (0x8000)  // Write: Set to start a single-conversion
#define ADS1015_REG_CONFIG_PGA_4_096V   (0x0200)  // +/-4.096V range = Gain 1

#define nl() UART1_Write(13); UART1_Write(10);
#define _24C256 0b10100000  // write address
#define ADS1015 0b10010000  // write address

#endif